﻿/**
 *
 * Copyright (c) 2002-2004 Bluetetra Software.  All rights reserved.
 *
 *
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED.  IN NO EVENT SHALL BLUETETRA SOFTWARE BE LIABLE FOR 
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL 
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE 
 * GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS 
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER 
 * IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR 
 * OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN 
 * IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *  
 * http://www.bluetetra.com
 *
 */

var wc_target = "content";
var wc_fileName = "wsdlComponentIndex.html";
var wc_nsFilterFileName = "nsFilter.html";


function WCN (href, name, appendNSFlag, children) {
	this.href = href;
	this.name = name;
	this.appendNSFlag = appendNSFlag;

	this.children = children;
	this.hasChild = (children != null) && (children.length>0);	
	
	this.namespace = null;
}

function WC (serviceList, messageList, portTypeList, bindingList)
{
	this.services = serviceList;
	this.messages = messageList;
	this.portTypes = portTypeList;
	this.bindings = bindingList;
}

function wc_showAllComponents() {
	parent._wsdlNsFilter = null;
	parent.index.location.href= "wsdl/" + wc_fileName;
}

function wc_filterComponents () {
	parent._href = "wsdl/" + wc_fileName;
	window.open(wc_nsFilterFileName, "_blank", 
		"height=200,width=400,location=no,menubar=no,scrollbars=yes,status=yes,resizable=yes,toolbar=no");

}

function wc_groupByNS (flag) {
	parent._groupByNSFlag = flag;
	parent.index.location.href= wc_fileName;	
}

function wc_setFilterToAll() {
	var nsList = new Array();
	var i = 0;

	for (var ns in wcDB) {
		nsList[i] = ns; 		
		i++;
	}

	parent._wsdlNsFilter = nsList;
}


function wc_showComponentsNoNS (nsList, componentList) {

	var components = new Array ();
	var n = 0;

	for (var i=0; i<componentList.length; i++) {
		var list = componentList [i];
		var namespace = nsList[i];

		if (list == null) {
			continue;
		}
	
		for (var j=0; j<list.length; j++) {
			components[n] = list[j];
			components[n].namespace = namespace;
			n++;	
		}	
	}
	
	components = components.sort(function (n1,n2) {return n1.name.toLowerCase().localeCompare (n2.name.toLowerCase());});

	wc_outputList (null, components);	
}


function wc_showComponentsNS (nsList, componentList) {

	for (var i=0; i<componentList.length; i++) {
		var list = componentList [i];
		var namespace = nsList[i];

		if (list == null) {
			continue;
		}
	
		for (var j=0; j<list.length; j++) {
			list[j].namespace = namespace;
		}	

		wc_outputList (namespace, list);	
	}
}


function wc_showComponents (nsList, componentList) {
	if (parent._groupByNSFlag) {
		wc_showComponentsNS (nsList, componentList)
	} else {
		wc_showComponentsNoNS (nsList, componentList)
	}
}

function wc_showServices() {
	if (parent._wsdlNsFilter == null) {
		wc_setFilterToAll();		
	}
	
	var nsList = parent._wsdlNsFilter;
	var services = new Array();
	var nss = new Array();

	for (var i=0; i<nsList.length; i++) {
		services [i] = wcDB [nsList[i]].services;	
		nss[i] = nsList[i];
	}		

	wc_showComponents (nss, services);
}

function wc_showMessages() {
	if (parent._wsdlNsFilter == null) {
		wc_setFilterToAll();		
	}
	
	var nsList = parent._wsdlNsFilter;
	var messages = new Array();
	var nss = new Array();

	for (var i=0; i<nsList.length; i++) {
		messages [i] = wcDB [nsList[i]].messages;	
		nss[i] = nsList[i];
	}		

	wc_showComponents (nss, messages);
}

function wc_showPortTypes() {
	if (parent._wsdlNsFilter == null) {
		wc_setFilterToAll();		
	}
	
	var nsList = parent._wsdlNsFilter;
	var portTypes = new Array();
	var nss = new Array();

	for (var i=0; i<nsList.length; i++) {
		portTypes [i] = wcDB [nsList[i]].portTypes;	
		nss[i] = nsList[i];
	}		

	wc_showComponents (nss, portTypes);
}


function wc_showBindings() {
	if (parent._wsdlNsFilter == null) {
		wc_setFilterToAll();		
	}
	
	var nsList = parent._wsdlNsFilter;
	var bindings = new Array();
	var nss = new Array();

	for (var i=0; i<nsList.length; i++) {
		bindings [i] = wcDB [nsList[i]].bindings;	
		nss[i] = nsList[i];
	}		

	wc_showComponents (nss, bindings);
}

function wc_getNodeText(node) {
	if (node.appendNSFlag) {
		return node.name + "("+encodeURI(node.namespace)+")";
	} else {
		return node.name;
	} 
}

function wc_outputLeaf (node) {
	var str = '<span class="leaf">'+
			  '<nobr><img src="img/leaf.gif" hspace="2" align="middle">'+
			  '<a class="chref" href="'+node.href+
			  '" title="'+ wc_getNodeText(node)+
			  '" target="'+ wc_target+'">'+ wc_getNodeText(node)+'</a></nobr>'+
			  '</span><br />'
	
	document.write (str);
}

function wc_outputNonLeaf (node) {
	//initially, the childnodes are hidden

	var str = '<div><div class="nonleaf">'+
			'<nobr><img style="cursor: pointer" src="img/plus.gif" hspace="2" align="middle" onclick="IClick(this)">'+
			'<a class="chref" href="'+node.href+
			'" title="'+ wc_getNodeText(node)+
			'" target="'+ wc_target +'">'+ wc_getNodeText(node)+'</a></nobr></div>'+
			'<div style="display:none;margin-left: 0.8em">';

	document.write (str);

	var childs = node.children;
	for (var i=0; i<childs.length; i++) {
		wc_outputTree (childs[i]);
	}					

	document.write ('</div></div>');
}

function wc_outputTree (node) {
	if (node.hasChild == false) {
		wc_outputLeaf (node);
	} else {
		wc_outputNonLeaf (node);
	}
}

function wc_outputList (ns, list) {	
	
	if (list == null || list.length<=0) {
		return;
	}

	if (parent._groupByNSFlag) {
		var fpath = wcNSMap[ns];

		var str = '<div class="nsBox"><div class="itemNS">'+
				'<nobr><img style="cursor: pointer" src="img/minus.gif" hspace="2" align="middle" onclick="IClick(this)">'+
				'<a class="chref" href="'+fpath+
				'" title="'+encodeURI(ns)+
				'" target="'+ wc_target +'">'+encodeURI(ns)+'</a></nobr></div>'+
				'<div style="margin-left: 0.5em">';

		document.write (str);
	}

	for (var i=0; i<list.length; i++) {
		wc_outputTree (list[i]);
	}
	
	if (parent._groupByNSFlag) {
		document.write ('</div></div>');
	}
}

var wcDB = new Array();
var wcNSMap = new Array();

wcDB ["http://glite.org/wms/wmproxy"] =  new WC (
					new Array(new WCN("1/service/WMProxy.html","WMProxy",false,null)),
					new Array(new WCN("1/message/addACLItemsRequest.html","addACLItemsRequest",false,null),new WCN("1/message/addACLItemsResponse.html","addACLItemsResponse",false,null),new WCN("1/message/AuthenticationFault.html","AuthenticationFault",false,null),new WCN("1/message/AuthorizationFault.html","AuthorizationFault",false,null),new WCN("1/message/GenericFault.html","GenericFault",false,null),new WCN("1/message/getACLItemsRequest.html","getACLItemsRequest",false,null),new WCN("1/message/getACLItemsResponse.html","getACLItemsResponse",false,null),new WCN("1/message/getCollectionTemplateRequest.html","getCollectionTemplateRequest",false,null),new WCN("1/message/getCollectionTemplateResponse.html","getCollectionTemplateResponse",false,null),new WCN("1/message/getDAGTemplateRequest.html","getDAGTemplateRequest",false,null),new WCN("1/message/getDAGTemplateResponse.html","getDAGTemplateResponse",false,null),new WCN("1/message/getDelegatedProxyInfoRequest.html","getDelegatedProxyInfoRequest",false,null),new WCN("1/message/getDelegatedProxyInfoResponse.html","getDelegatedProxyInfoResponse",false,null),new WCN("1/message/getFreeQuotaRequest.html","getFreeQuotaRequest",false,null),new WCN("1/message/getFreeQuotaResponse.html","getFreeQuotaResponse",false,null),new WCN("1/message/getIntParametricJobTemplateRequest.html","getIntParametricJobTemplateRequest",false,null),new WCN("1/message/getIntParametricJobTemplateResponse.html","getIntParametricJobTemplateResponse",false,null),new WCN("1/message/getJobTemplateRequest.html","getJobTemplateRequest",false,null),new WCN("1/message/getJobTemplateResponse.html","getJobTemplateResponse",false,null),new WCN("1/message/getMaxInputSandboxSizeRequest.html","getMaxInputSandboxSizeRequest",false,null),new WCN("1/message/getMaxInputSandboxSizeResponse.html","getMaxInputSandboxSizeResponse",false,null),new WCN("1/message/getOutputFileListRequest.html","getOutputFileListRequest",false,null),new WCN("1/message/getOutputFileListResponse.html","getOutputFileListResponse",false,null),new WCN("1/message/getProxyReqRequest.html","getProxyReqRequest",false,null),new WCN("1/message/getProxyReqResponse.html","getProxyReqResponse",false,null),new WCN("1/message/GetQuotaManagementFault.html","GetQuotaManagementFault",false,null),new WCN("1/message/getSandboxDestURIRequest.html","getSandboxDestURIRequest",false,null),new WCN("1/message/getSandboxDestURIResponse.html","getSandboxDestURIResponse",false,null),new WCN("1/message/getStringParametricJobTemplateRequest.html","getStringParametricJobTemplateRequest",false,null),new WCN("1/message/getStringParametricJobTemplateResponse.html","getStringParametricJobTemplateResponse",false,null),new WCN("1/message/getTotalQuotaRequest.html","getTotalQuotaRequest",false,null),new WCN("1/message/getTotalQuotaResponse.html","getTotalQuotaResponse",false,null),new WCN("1/message/getVersionRequest.html","getVersionRequest",false,null),new WCN("1/message/getVersionResponse.html","getVersionResponse",false,null),new WCN("1/message/InvalidArgumentFault.html","InvalidArgumentFault",false,null),new WCN("1/message/jobCancelRequest.html","jobCancelRequest",false,null),new WCN("1/message/jobCancelResponse.html","jobCancelResponse",false,null),new WCN("1/message/jobListMatchRequest.html","jobListMatchRequest",false,null),new WCN("1/message/jobListMatchResponse.html","jobListMatchResponse",false,null),new WCN("1/message/jobPurgeRequest.html","jobPurgeRequest",false,null),new WCN("1/message/jobPurgeResponse.html","jobPurgeResponse",false,null),new WCN("1/message/jobRegisterRequest.html","jobRegisterRequest",false,null),new WCN("1/message/jobRegisterResponse.html","jobRegisterResponse",false,null),new WCN("1/message/jobStartRequest.html","jobStartRequest",false,null),new WCN("1/message/jobStartResponse.html","jobStartResponse",false,null),new WCN("1/message/jobSubmitRequest.html","jobSubmitRequest",false,null),new WCN("1/message/jobSubmitResponse.html","jobSubmitResponse",false,null),new WCN("1/message/JobUnknownFault.html","JobUnknownFault",false,null),new WCN("1/message/NoSuitableResourcesFault.html","NoSuitableResourcesFault",false,null),new WCN("1/message/OperationNotAllowedFault.html","OperationNotAllowedFault",false,null),new WCN("1/message/putProxyRequest.html","putProxyRequest",false,null),new WCN("1/message/putProxyResponse.html","putProxyResponse",false,null),new WCN("1/message/removeACLItemRequest.html","removeACLItemRequest",false,null),new WCN("1/message/removeACLItemResponse.html","removeACLItemResponse",false,null)),
					new Array(new WCN("1/porttype/WMProxy_PortType.html","WMProxy_PortType",false,new Array(new WCN("1/operation/addACLItems_20.html","addACLItems",false,null),new WCN("1/operation/getACLItems_19.html","getACLItems",false,null),new WCN("1/operation/getCollectionTemplate_16.html","getCollectionTemplate",false,null),new WCN("1/operation/getDAGTemplate_15.html","getDAGTemplate",false,null),new WCN("1/operation/getDelegatedProxyInfo_22.html","getDelegatedProxyInfo",false,null),new WCN("1/operation/getFreeQuota_10.html","getFreeQuota",false,null),new WCN("1/operation/getIntParametricJobTemplate_17.html","getIntParametricJobTemplate",false,null),new WCN("1/operation/getJobTemplate_14.html","getJobTemplate",false,null),new WCN("1/operation/getMaxInputSandboxSize_7.html","getMaxInputSandboxSize",false,null),new WCN("1/operation/getOutputFileList_12.html","getOutputFileList",false,null),new WCN("1/operation/getProxyReq_0.html","getProxyReq",false,null),new WCN("1/operation/getSandboxDestURI_8.html","getSandboxDestURI",false,null),new WCN("1/operation/getStringParametricJobTemplate_18.html","getStringParametricJobTemplate",false,null),new WCN("1/operation/getTotalQuota_9.html","getTotalQuota",false,null),new WCN("1/operation/getVersion_2.html","getVersion",false,null),new WCN("1/operation/jobCancel_6.html","jobCancel",false,null),new WCN("1/operation/jobListMatch_13.html","jobListMatch",false,null),new WCN("1/operation/jobPurge_11.html","jobPurge",false,null),new WCN("1/operation/jobRegister_3.html","jobRegister",false,null),new WCN("1/operation/jobStart_4.html","jobStart",false,null),new WCN("1/operation/jobSubmit_5.html","jobSubmit",false,null),new WCN("1/operation/putProxy_1.html","putProxy",false,null),new WCN("1/operation/removeACLItem_21.html","removeACLItem",false,null)))),
					new Array(new WCN("1/binding/WMProxy.html","WMProxy",false,new Array(new WCN("1/operation/addACLItems_20.html","addACLItems",false,null),new WCN("1/operation/getACLItems_19.html","getACLItems",false,null),new WCN("1/operation/getCollectionTemplate_16.html","getCollectionTemplate",false,null),new WCN("1/operation/getDAGTemplate_15.html","getDAGTemplate",false,null),new WCN("1/operation/getDelegatedProxyInfo_22.html","getDelegatedProxyInfo",false,null),new WCN("1/operation/getFreeQuota_10.html","getFreeQuota",false,null),new WCN("1/operation/getIntParametricJobTemplate_17.html","getIntParametricJobTemplate",false,null),new WCN("1/operation/getJobTemplate_14.html","getJobTemplate",false,null),new WCN("1/operation/getMaxInputSandboxSize_7.html","getMaxInputSandboxSize",false,null),new WCN("1/operation/getOutputFileList_12.html","getOutputFileList",false,null),new WCN("1/operation/getProxyReq_0.html","getProxyReq",false,null),new WCN("1/operation/getSandboxDestURI_8.html","getSandboxDestURI",false,null),new WCN("1/operation/getStringParametricJobTemplate_18.html","getStringParametricJobTemplate",false,null),new WCN("1/operation/getTotalQuota_9.html","getTotalQuota",false,null),new WCN("1/operation/getVersion_2.html","getVersion",false,null),new WCN("1/operation/jobCancel_6.html","jobCancel",false,null),new WCN("1/operation/jobListMatch_13.html","jobListMatch",false,null),new WCN("1/operation/jobPurge_11.html","jobPurge",false,null),new WCN("1/operation/jobRegister_3.html","jobRegister",false,null),new WCN("1/operation/jobStart_4.html","jobStart",false,null),new WCN("1/operation/jobSubmit_5.html","jobSubmit",false,null),new WCN("1/operation/putProxy_1.html","putProxy",false,null),new WCN("1/operation/removeACLItem_21.html","removeACLItem",false,null))))
					);

wcNSMap ["http://glite.org/wms/wmproxy"] = "1/index.html";
